'-------------------------------------------------------------------------------
'UNO_spiLogger.BAS  Shift in/out 25LC512
'-------------------------------------------------------------------------------
$regfile = "m328pdef.dat"                                   'ATmega328p
$crystal = 16000000                                         '16 MHz
$baud = 9600

Dim B As Bit
Dim Dout As Byte
Dim Din As Byte
Dim N As Byte
Dim I As Word
Dim Ticks As Word
Dim Seconds As Word
Dim Addr As Word
Dim U As Word

Config Spi = Soft , Din = Pinb.4 , Dout = Portb.3 , Ss = None , Clock = Portb.5 , Mode = 0
Spiinit                                                     'Init SPI state and pins.


Config Adc = Single , Prescaler = 32 , Reference = Avcc
Start Adc


Config Timer0 = Timer , Prescale = 256
On Ovf0 Tim0_isr
Enable Timer0


S1 Alias Pinc.0
Portc.0 = 1                                                 'Pullup
S2 Alias Pinc.1
Portc.1 = 1

Cs Alias Portb.2
Ddrb.2 = 1
Cs = 1


Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2
Config Lcd = 16 * 2

Cls
Cursor Off

Do
  Do
    If S1 = 0 Then Exit Do
    If S2 = 0 Then Exit Do
    Locate 1 , 1
    Lcd Seconds
    Lcd "   "
    Waitms 500
    Locate 2 , 1
    Lcd U
    Lcd "   "
    Waitms 500
    If Seconds = 65535 Then Disable Interrupts
  Loop

  If S1 = 0 Then
    Cls
    Cs = 1
    Waitms 1
    Seconds = 0
    Enable Interrupts
  End If
  If S2 = 0 Then
     Disable Interrupts
     Cs = 1
     Waitms 100
     Cs = 0
     Dout = 4                                               'write disable
     Spiout Dout , 1
     Cs = 1
     Waitms 1
     Cs = 0
     Dout = 3                                               'read
     Spiout Dout , 1
     Dout = 0                                               'A8...A15
     Spiout Dout , 1
     Dout = 0                                               'A0...A7
     Spiout Dout , 1
     I = 0
     Do
       Locate 1 , 1
       Lcd I
       Lcd "  "
       Spiin Din , 1
       Locate 2 , 1
       Lcd Din
       Lcd "  "
       Print I ;
       Print "  ";
       Print Din
       Waitms 200
       I = I + 1
       If I >= 65535 Then Exit Do
     Loop Until S1 = 0
  End If
Loop




Tim0_isr:
  '4000 s
  Timer0 = 6
  Ticks = Ticks + 1
  If Ticks = 250 Then
    Ticks = 0
    U = Getadc(4)
    U = U / 4
    Addr = Seconds
    Addr = Addr And 127
    If Addr = 0 Then                                        'start of page
      Cs = 0
      Dout = 6                                              'write enable
      Spiout Dout , 1
      Cs = 1
      Waitus 100
      Cs = 0
      Dout = 2                                              'write
      Spiout Dout , 1
      Waitus 100
      Cs = 0
      Dout = 3
      Addr = High(seconds)
      Dout = Addr                                           'A8...A15
      Spiout Dout , 1
      Addr = Low(seconds)
      Dout = Addr                                           'A0...A7
      Spiout Dout , 1
    End If
    Dout = U
    Spiout Dout , 1
    Addr = Seconds
    Addr = Addr And 127
    If Addr = 127 Then                                      'End of page
      Cs = 1
    End If
    Print Seconds
    Seconds = Seconds + 1
    If Seconds = 0 Then Seconds = 65535
 End If
Return