'-------------------------------------------------------------------------------
'UNO_spiEE1.BAS  Shift in/out 25LC512
'-------------------------------------------------------------------------------
$regfile = "m328pdef.dat"                                   'ATmega328p
$crystal = 16000000                                         '16 MHz
$baud = 9600

Dim Addr As Byte
Dim B As Bit
Dim Dout As Byte
Dim Din As Byte
Dim N As Byte
Dim I As Word
Dim Highbyte As Byte
Dim Lowbyte As Byte

Declare Sub Spioutin()

S1 Alias Pinc.0
Portc.0 = 1                                                 'Pullup
S2 Alias Pinc.1
Portc.1 = 1
                                               'Pullup
Sck Alias Portb.5
Ddrb.5 = 1
Mosi Alias Portb.3
Ddrb.3 = 1
Cs Alias Portb.2
Ddrb.2 = 1
Miso Alias Pinb.4

Cs = 1
Mosi = 0
Sck = 0

Waitms 20

Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2
Config Lcd = 16 * 2

Goto Flash_prog
'Goto Flash_erase

Cls
Cursor Off
  Waitms 200

  Cs = 0                                                    'Reset

  Waitms 20

  Dout = &HAC
  Spioutin
  Dout = &H53
  Spioutin
  Dout = &H00
  Spioutin
  Locate 1 , 1                                              'status 2
  Lcd Din
  Ddrb.5 = 0                                                'SPI hochohmig schalten
  Ddrb.3 = 0
  Cs = 1                                                    'Reset Ende
Do
Loop

Flash_erase:

Cls
Cursor Off
  Waitms 200


  Cs = 0                                                    'Reset

  Waitms 20

  Dout = &HAC
  Spioutin
  Dout = &H53
  Spioutin
  Dout = &H00
  Spioutin
  Locate 1 , 1
  Lcd Din                                                   'zeigt 83
  Dout = &H00
  Spioutin

  Dout = &HAC
  Spioutin
  Dout = &H80                                               'Erase
  Spioutin
  Dout = &H00
  Spioutin
  Dout = &H00
  Spioutin

  Waitms 10                                                 'Lschen



  Ddrb.5 = 0                                                'SPI hochohmig schalten
  Ddrb.3 = 0
  Cs = 1                                                    'Reset Ende
Do
Loop


Flash_prog:

Cls
Cursor Off
  Waitms 200


  Cs = 0                                                    'Reset

  Waitms 20

  Dout = &HAC
  Spioutin
  Dout = &H53
  Spioutin
  Dout = &H00
  Spioutin
  Locate 1 , 1
  Lcd Din                                                   'zeigt 83
  Dout = &H00
  Spioutin


  Dout = &HAC
  Spioutin
  Dout = &H80                                               'Erase
  Spioutin
  Dout = &H00
  Spioutin
  Dout = &H00
  Spioutin

  Waitms 20                                                 'Lschen



  Restore Progdata                                          'Adresse der Sound-Daten

  For Addr = 0 To 15
    Read Lowbyte
    Read Highbyte

    Dout = &H40
    Spioutin
    Dout = &H00
    Spioutin
    Dout = Addr
    Spioutin
    Dout = Lowbyte
    Spioutin

    Dout = &H48
    Spioutin
    Dout = &H00
    Spioutin
    Dout = Addr
    Spioutin
    Dout = Highbyte
    Spioutin
  Next Addr

  Dout = &H4C
  Spioutin
  Dout = &H00
  Spioutin
  Dout = &H00
  Spioutin
  Dout = &H00
  Spioutin

  Waitms 50


  Ddrb.5 = 0                                                'SPI hochohmig schalten
  Ddrb.3 = 0
  Cs = 1                                                    'Reset Ende
Do
Loop





Sub Spioutin
  Din = 0
  For N = 0 To 7
    Shift Din , Left
    Din = Din + Miso
    If Dout.7 = 1 Then Mosi = 1 Else Mosi = 0
    Waitms 3
    Sck = 1
    Waitms 2
    Sck = 0
    Waitms 2
    Shift Dout , Left
  Next N
End Sub



Progdata:
Data &H00 , &HC0 , &HBB , &H9A , &HC3 , &H9A , &H0F , &HEF , &H0A , &H95 , &HF1 , &HF7 , &HC3 , &H98 , &H0F , &HEF
Data &H0A , &H95 , &HF1 , &HF7 , &HF7 , &HCF , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00 , &H00



'Prgdata von Blink1.asm  LED mit Vorwiderstand an PB3

'      .include "tn13def.inc"

rjmp Anfang
Anfang:
      sbi   ddrb,3      ;Datenrichtungsbit
Schleife:
      sbi   portb,3     ;PB3 = 1
      ldi   r16,255     ;r16 laden
Warten1:
      dec   r16         ;r16 - 1
      brne  Warten1
      cbi   portb,3     ;PB3 = 0
      ldi   r16,255     ;r16 laden
Warten2:
      dec   r16         ;r16 -1
      brne  Warten2
rjmp  Schleife


